#include "roman.h"

namespace Roman {

std::string ConversionContext::toR(textNumeric val)
{
  std::string ret;
  //Pad val to be a multiple of (maxVal/2) long
  if (val.length() % maxVal/2) {
    val = std::string(((val.length() / (maxVal/2) + 1)*maxVal/2) - val.length(), '0') + val;
  }
  std::string valR = val;
  std::reverse(valR.begin(), valR.end());
  //std::cout<<valR<<std::endl;
  //Recurse if overly large)
  if (val.length() > maxVal/2) {
    ret = toERoman(val.substr(0, val.size()-(maxVal/2+1)), depth+1, maxVal);
  }
  val = valR.substr(0, maxVal/2+1);
  for (unsigned int s = val.length() - 1; ; --s) {
    //std::cout<<s<<';'<<(val%(valVals[s]*10))/valVals[s]<<std::endl;
    //if val is greater than current char then get last digit
    switch (val[s]) {
    case '9': //IX
      ret += repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth);
      if (s) //X
        ret += repeat('(',depth) + values[valVals[2*s+2]] + repeat(')',depth);
      else //(I)
        ret += repeat('(',depth+1) + values[valVals[0]] + repeat(')',depth+1);
      break;
    case '8': //VIII
      ret += repeat('(',depth) + values[valVals[2*s+1]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[s]] + repeat(')',depth);
      break;
    case '7': //VII
      ret += repeat('(',depth) + values[valVals[2*s+1]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[s]] + repeat(')',depth);
      break;
    case '6': //VI
      ret += repeat('(',depth) + values[valVals[2*s+1]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[s]] + repeat(')',depth);
      break;
    case '5': //V
      ret += repeat('(',depth) + values[valVals[2*s+1]] + repeat(')',depth);
      break;
    case '4': //IV
      ret += repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[2*s+1]] + repeat(')',depth);
      break;
    case '3': //III
      ret += repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth);
      break;
    case '2': //II
      ret += repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth)
        + repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth);
      break;
    case '1': //I
      ret += repeat('(',depth) + values[valVals[2*s]] + repeat(')',depth);
      break;
    default:
      break;
    }
    if (!s) { //Because testing in the loop statement was giving odd results
      break;
    }
  }
  return std::move(ret);
}

}